<?xml version="1.0" ?>
<!--
    
    Role: generates the stylesheet that contains all xsl templates for processing the TAs over run-time targets. This generated code is called "TA plug-ins". The input of the generation is the profile mark-up with embedded TA definitions.

    For more information on the Web Services Interoperability Organization, 
    please see http://www.ws-i.org/.

    @author Jacques Durand (Fujitsu America)
    @version 0.9, 18/January/2009

  -->


<xsl:stylesheet 
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
   xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
   xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
   xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" 
   xmlns:wsoap="http://schemas.xmlsoap.org/wsdl/soap/" 
   xmlns:soap="http://www.w3.org/2003/05/soap-envelope"
   xmlns:wsit="http://www.ws-i.org/testing/2007/03/test/" 
   xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/" 
   xmlns:wsia="http://www.ws-i.org/testing/2003/03/assertions/" 
   xmlns:fn="http://www.w3.org/2005/xpath-functions" 
   xmlns:p="http://www.ws-i.org/2002/08/12/ProfileDoc-2.0.xsd"
   version="2.0">
  <xsl:output method="xml" indent="yes"/>

  <!--  ******************* Global parameters -->

<xsl:variable name="globalparameters">
  <!-- name and version# of the XSLT engine used to generate the analyzer 
       (i.e. used to run make-plugin.xsl) -->
  <wsit:analyzergenxsltname>Saxon B</wsit:analyzergenxsltname>
  <wsit:analyzergenxsltvn>V0.9</wsit:analyzergenxsltvn>
</xsl:variable>


  <!--  ******************* generate header part -->
  <xsl:template match="p:profile" priority="1">

    <xsl:text>&#10;</xsl:text>
    <xsl:text disable-output-escaping="yes">&#10;&lt;?xml-stylesheet type="text/xsl" ?&gt;</xsl:text>
    <xsl:text>&#10;</xsl:text>

    <xsl:text>&#10;</xsl:text>
    <xsl:text disable-output-escaping="yes">&#10;&lt;xsl:stylesheet version="2.0" &#10;</xsl:text> 
    <xsl:text disable-output-escaping="yes">xmlns:xsl="http://www.w3.org/1999/XSL/Transform" &#10;</xsl:text> 
    <xsl:text disable-output-escaping="yes">xmlns="http://www.ws-i.org/testing/2007/03/test/" &#10;</xsl:text> 
    <xsl:text disable-output-escaping="yes">xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" &#10;</xsl:text> 
    <xsl:text disable-output-escaping="yes">xmlns:xsd="http://www.w3.org/2001/XMLSchema" &#10;</xsl:text> 
    <xsl:text disable-output-escaping="yes">xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" &#10;</xsl:text> 
    <xsl:text disable-output-escaping="yes">xmlns:soap11="http://schemas.xmlsoap.org/soap/envelope/" &#10;</xsl:text> 
    <xsl:text disable-output-escaping="yes">xmlns:soap12="http://www.w3.org/2003/05/soap-envelope" &#10;</xsl:text> 
    <!-- xsl:text disable-output-escaping="yes">xmlns:soap="http://www.w3.org/2003/05/soap-envelope" &#10;</xsl:text --> 
    <xsl:text disable-output-escaping="yes">xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" &#10;</xsl:text> 
    <xsl:text disable-output-escaping="yes">xmlns:xenc="http://www.w3.org/2001/04/xmlenc#" &#10;</xsl:text> 
    <xsl:text disable-output-escaping="yes">xmlns:wsoap12="http://schemas.xmlsoap.org/wsdl/soap12/" &#10;</xsl:text> 
    <xsl:text disable-output-escaping="yes">xmlns:wsoap11="http://schemas.xmlsoap.org/wsdl/soap/" &#10;</xsl:text> 
    <xsl:text disable-output-escaping="yes">xmlns:soapbind="http://schemas.xmlsoap.org/wsdl/soap/" &#10;</xsl:text> 
    <xsl:text disable-output-escaping="yes">xmlns:wsil="http://www.ws-i.org/testing/2008/02/log/" &#10;</xsl:text> 
    <xsl:text disable-output-escaping="yes">xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/" &#10;</xsl:text> 
    <xsl:text disable-output-escaping="yes">xmlns:fn="http://www.w3.org/2005/xpath-functions" &#10;</xsl:text> 
    <xsl:text disable-output-escaping="yes">xmlns:wsa="http://www.w3.org/2005/08/addressing" &#10;</xsl:text>
    <xsl:text disable-output-escaping="yes">xmlns:wsam="http://www.w3.org/2007/05/addressing/metadata" &#10;</xsl:text>
    <xsl:text disable-output-escaping="yes">xmlns:ds="http://www.w3.org/2000/09/xmldsig#" &#10;</xsl:text>
    <xsl:text disable-output-escaping="yes">xmlns:wsu="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd" &#10;</xsl:text>
    <xsl:text disable-output-escaping="yes">xmlns:wsse="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd" &#10;</xsl:text>
    <xsl:text disable-output-escaping="yes">xmlns:wssc="http://docs.oasis-open.org/ws-sx/ws-secureconversation/200512" &#10;</xsl:text>
    <xsl:text disable-output-escaping="yes">xmlns:wsmc="http://docs.oasis-open.org/ws-rx/wsmc/200702" &#10;</xsl:text>
    <xsl:text disable-output-escaping="yes">xmlns:wst="http://docs.oasis-open.org/ws-sx/ws-trust/200512" &#10;</xsl:text>
    <xsl:text disable-output-escaping="yes">xmlns:wsrm="http://docs.oasis-open.org/ws-rx/wsrm/200702" &gt;&#10;</xsl:text>
    <xsl:text>&#10;</xsl:text>
    <xsl:text>&#10;</xsl:text>

    <xsl:element name="xsl:output"> 
      <xsl:attribute name="method" namespace="">xml</xsl:attribute>
      <xsl:attribute name="indent" namespace="">yes</xsl:attribute>
    </xsl:element>

    <xsl:call-template name="setAnalyzerInfo"/>

    <xsl:apply-templates select="/p:profile//p:testAssertion[not(@enable) or @enable = 'true']"/>

    <xsl:element name="xsl:template"> 
      <xsl:attribute name="mode" namespace="">TA</xsl:attribute>
      <xsl:attribute name="match" namespace="">node()</xsl:attribute>
      <xsl:attribute name="priority" namespace="">-1</xsl:attribute>

      <xsl:element name="xsl:param"> 
	<xsl:attribute name="name" namespace="">tgtype</xsl:attribute>
      </xsl:element> 
      <xsl:element name="xsl:param"> 
	<xsl:attribute name="name" namespace="">target</xsl:attribute>
      </xsl:element> 
      <xsl:element name="xsl:param"> 
	<xsl:attribute name="name" namespace="">tempresults</xsl:attribute>
      </xsl:element> 
    </xsl:element> 

    <!-- xsl:call-template name="lasttemplate">
    </xsl:call-template -->

    <xsl:text>&#10;</xsl:text>
    <xsl:text disable-output-escaping="yes">&#10;&lt;/xsl:stylesheet&gt;</xsl:text>
    <xsl:text>&#10;</xsl:text>

  </xsl:template>

  <xsl:template name="lasttemplate">

    <xsl:element name="xsl:template"> 
      <xsl:attribute name="mode" namespace="">TA</xsl:attribute>
      <xsl:attribute name="match" namespace="">node()</xsl:attribute>
      <xsl:attribute name="priority" namespace="">-1</xsl:attribute>

      <xsl:element name="xsl:param"> 
	<xsl:attribute name="name" namespace="">tgtype</xsl:attribute>
      </xsl:element> 
      <xsl:element name="xsl:param"> 
	<xsl:attribute name="name" namespace="">target</xsl:attribute>
      </xsl:element> 
      <xsl:element name="xsl:param"> 
	<xsl:attribute name="name" namespace="">tempresults</xsl:attribute>
      </xsl:element> 
      <xsl:element name="xsl:param"> 
	<xsl:attribute name="name" namespace="">taoutlist</xsl:attribute>
      </xsl:element> 

      <xsl:element name="xsl:variable"> 
	<xsl:attribute name="name" namespace="">entryid</xsl:attribute>
	<xsl:element name="xsl:call-template"> 
	  <xsl:attribute name="name" namespace="">idpick</xsl:attribute>
	  <xsl:element name="xsl:with-param"> 
	    <xsl:attribute name="name" namespace="">target</xsl:attribute>
	    <xsl:attribute name="select" namespace="">$target</xsl:attribute>
	  </xsl:element> 
	</xsl:element> 
      </xsl:element> 

      <xsl:element name="xsl:variable"> 
	<xsl:attribute name="name" namespace="">logentry</xsl:attribute>
	<xsl:element name="xsl:value-of"> 
	  <xsl:attribute name="select" namespace="">$entryid</xsl:attribute>
	</xsl:element> 
      </xsl:element> 

	<!-- CHG -->
	<xsl:variable name="message_tas">
	<xsl:call-template name="getalltas">
	  <xsl:with-param name="tatype">message</xsl:with-param>
	  <xsl:with-param name="tapos" select="fn:count(//*:testAssertion[not(@enable) or @enable = 'true'][fn:starts-with(@id, 'BP1') or fn:starts-with(@id, 'RSP')])"/>
	</xsl:call-template>
	</xsl:variable>
	<xsl:variable name="description_tas">
	<xsl:call-template name="getalltas">
	  <xsl:with-param name="tatype">description</xsl:with-param>
	  <xsl:with-param name="tapos" select="fn:count(//*:testAssertion[not(@enable) or @enable = 'true'][fn:starts-with(@id, 'BP2')])"/>
	</xsl:call-template>
	</xsl:variable>

      <xsl:element name="xsl:variable"> 
	<xsl:attribute name="name" namespace="">allactivetas</xsl:attribute>
	<xsl:attribute name="as" namespace="">xsd:string</xsl:attribute>

	<!-- CHG -->
	<xsl:element name="xsl:choose"> 
	  <xsl:element name="xsl:when"> 
	    <xsl:attribute name="test" namespace="">$tgtype = 'message'</xsl:attribute>
		<xsl:value-of select="$message_tas"/>
	      </xsl:element>
	  <xsl:element name="xsl:when"> 
	    <xsl:attribute name="test" namespace="">$tgtype = 'description'</xsl:attribute>
		<xsl:value-of select="$description_tas"/>
	      </xsl:element>
	  <xsl:element name="xsl:otherwise">;</xsl:element> 
	 </xsl:element> <!-- choose --> 
	</xsl:element> <!-- variable --> 

      <xsl:element name="xsl:for-each"> 
	<xsl:attribute name="select" namespace="">fn:tokenize(xsd:string($allactivetas), ';')</xsl:attribute>

	<xsl:element name="xsl:variable"> 
	  <xsl:attribute name="name" namespace="">oneta</xsl:attribute>
	  <xsl:element name="xsl:value-of"> 
	    <xsl:attribute name="select" namespace="">.</xsl:attribute>
	  </xsl:element> 
	</xsl:element> 

	<xsl:element name="xsl:if"> 
	  <xsl:attribute name="test" namespace="">not($tempresults//*:test[@id eq $logentry][@tassertion eq $oneta ]) and not (fn:contains($taoutlist, $oneta))</xsl:attribute>

	  <xsl:element name="xsl:element"> 
	    <xsl:attribute name="name">test</xsl:attribute>
	    <!-- xsl:attribute name="namespace">http://www.w3.org/2009/testassertionsguideline</xsl:attribute -->

	    <xsl:element name="xsl:attribute"> 
	      <xsl:attribute name="name" namespace="">tassertion</xsl:attribute>
	      <xsl:element name="xsl:value-of">
		<xsl:attribute name="select">$oneta</xsl:attribute>
	      </xsl:element>
	    </xsl:element> 

	    <xsl:element name="xsl:attribute"> 
	      <xsl:attribute name="name" namespace="">artifact</xsl:attribute>
	      <xsl:element name="xsl:value-of">
		<xsl:attribute name="select">$tgtype</xsl:attribute>
	      </xsl:element>
	    </xsl:element> 

	    <xsl:element name="xsl:attribute"> 
	      <xsl:attribute name="name" namespace="">id</xsl:attribute>
	      <xsl:element name="xsl:value-of">
		<xsl:attribute name="select">$logentry</xsl:attribute>
	      </xsl:element>
	    </xsl:element> 

	    <xsl:element name="xsl:attribute"> 
	      <xsl:attribute name="name" namespace="">target</xsl:attribute>
	      <xsl:element name="xsl:value-of">
		<xsl:attribute name="select">$target</xsl:attribute>
	      </xsl:element>
	    </xsl:element> 

	    <xsl:element name="xsl:attribute"> 
	      <xsl:attribute name="name" namespace="">result</xsl:attribute>
	      <xsl:text>notappl</xsl:text>
	    </xsl:element> 
	    <xsl:element name="xsl:value-of">
	      <xsl:attribute name="select">$taoutlist</xsl:attribute>
	    </xsl:element>

	  </xsl:element> 

	</xsl:element> <!-- if -->
	
      </xsl:element> <!-- for-each -->
    </xsl:element> <!-- template -->
  </xsl:template> <!-- lasttemplate -->


  <xsl:template match="/p:profile//p:testAssertion" priority="1">

    <xsl:element name="xsl:template"> 

      <xsl:attribute name="mode" namespace="">TA</xsl:attribute>
      <xsl:attribute name="match" namespace="">
	<xsl:value-of select="p:target"/>
      </xsl:attribute>
      <xsl:attribute name="priority" namespace="">
	<xsl:value-of select="fn:translate(@id,'aAbBcCdDeEfFgGhHiIjJkKlLmMnNoOpPqQrRsStTuUvVwWxXyYzZ','001122334455667788990011223344556677889900112233')"/>
      </xsl:attribute>

      <xsl:element name="xsl:param"> 
	<xsl:attribute name="name" namespace="">tgtype</xsl:attribute>
      </xsl:element> 
      <xsl:element name="xsl:param"> 
	<xsl:attribute name="name" namespace="">target</xsl:attribute>
      </xsl:element> 
      <xsl:element name="xsl:param"> 
	<xsl:attribute name="name" namespace="">tempresults</xsl:attribute>
      </xsl:element> 
      <xsl:element name="xsl:param"> 
	<xsl:attribute name="name" namespace="">taoutlist</xsl:attribute>
      </xsl:element> 

      <xsl:element name="xsl:variable"> 
	<xsl:attribute name="name" namespace="">prescription</xsl:attribute>
	<xsl:value-of select="p:prescription/@level"/>
      </xsl:element> 

      <xsl:element name="xsl:variable"> 
	<xsl:attribute name="name" namespace="">entryid</xsl:attribute>
	<xsl:element name="xsl:call-template"> 
	  <xsl:attribute name="name" namespace="">idpick</xsl:attribute>
	  <xsl:element name="xsl:with-param"> 
	    <xsl:attribute name="name" namespace="">target</xsl:attribute>
	    <xsl:attribute name="select" namespace="">$target</xsl:attribute>
	  </xsl:element> 
	</xsl:element> 
      </xsl:element> 

      <xsl:element name="xsl:variable"> 
	<xsl:attribute name="name" namespace="">logentry</xsl:attribute>
	<xsl:element name="xsl:value-of"> 
	  <xsl:attribute name="select" namespace="">$entryid</xsl:attribute>
	</xsl:element> 
      </xsl:element> 

<!-- CHG -->
      <xsl:element name="xsl:variable"> 
	<xsl:attribute name="name" namespace="">nopreviousres</xsl:attribute>
	<xsl:attribute name="select" namespace="">
	  <xsl:value-of select="concat('not($tempresults//*:test[@id eq $logentry][@tassertion eq &quot;', @id , '&quot;])')"/>
	</xsl:attribute>
      </xsl:element> 

      <xsl:element name="xsl:variable"> 
	<xsl:attribute name="name" namespace="">newtaoutlist</xsl:attribute>
	<xsl:element name="xsl:choose"> 
	  <xsl:element name="xsl:when"> 
	    <xsl:attribute name="test" namespace="">$nopreviousres eq fn:true()</xsl:attribute>
	    <xsl:element name="xsl:value-of">
	      <xsl:attribute name="select">
		<xsl:value-of select="concat('concat($taoutlist, &quot;', @id , '&quot;, &quot;;&quot;)')"/>
	      </xsl:attribute>
	    </xsl:element> 
	  </xsl:element> <!-- when -->
	  <xsl:element name="xsl:otherwise"> 
	    <xsl:element name="xsl:value-of">
	      <xsl:attribute name="select">$taoutlist</xsl:attribute>
	    </xsl:element> 
	  </xsl:element> <!-- otherwise -->
	</xsl:element> <!-- choose -->
      </xsl:element>  <!-- var -->

      <xsl:element name="xsl:if"> 

	<xsl:attribute name="test" namespace="">$nopreviousres eq fn:true()</xsl:attribute>
	  <!-- xsl:value-of select="concat('not($tempresults//*:test[@id eq $logentry][@tassertion eq &quot;', @id , '&quot;])')"/ -->

      <xsl:element name="xsl:variable"> 
	<xsl:attribute name="name" namespace="">mytarget</xsl:attribute>
	<xsl:attribute name="select" namespace="">self::node()</xsl:attribute>
      </xsl:element> 

	<xsl:if  test="p:cotarget">
<!-- CHG -->

	  <xsl:element name="xsl:variable"> 
	    <xsl:attribute name="name" namespace="">
	      <xsl:value-of select="concat('cotarget_', p:cotarget[1]/@name)"/>
	    </xsl:attribute>
	    <xsl:attribute name="select" namespace="">
		  <!-- xsl:text>for $mytarget in self::node() return &#10;</xsl:text -->
		  <xsl:value-of select="fn:replace (p:cotarget[1], '\$target', '\$mytarget') "/>
		  <xsl:text>[1]</xsl:text>
	    </xsl:attribute>
	  </xsl:element> 

	<xsl:if  test="count(p:cotarget) gt 1">

	  <xsl:element name="xsl:variable"> 
	    <xsl:attribute name="name" namespace="">
	      <xsl:value-of select="concat('cotarget_', p:cotarget[2]/@name)"/>
	    </xsl:attribute>
	    <xsl:attribute name="select" namespace="">
		  <xsl:value-of select="fn:replace (
					fn:replace(
					p:cotarget[2], '\$target', '\$mytarget'),
					fn:concat('\$',p:cotarget[1]/@name), fn:concat('\$cotarget_', p:cotarget[1]/@name) )"/>
		  <xsl:text>[1]</xsl:text>
	    </xsl:attribute>
	  </xsl:element> 

	</xsl:if>
	</xsl:if>

	<xsl:if  test="@preReq and @preReq ne ''">
	  <xsl:element name="xsl:variable"> 
	    <xsl:attribute name="name" namespace="">prereqres</xsl:attribute>
	    <xsl:element name="xsl:value-of"> 
	      <xsl:attribute name="select" namespace="">
		<xsl:text>concat(</xsl:text>
		<xsl:call-template name="reportprereqs">
		  <xsl:with-param name="prereqstr" select="@preReq"/>
		</xsl:call-template>
		<xsl:text>)</xsl:text>
	      </xsl:attribute>
	    </xsl:element> 
	  </xsl:element> 
	</xsl:if>


	<xsl:element name="xsl:choose"> 
	  <xsl:element name="xsl:when"> 
	    <xsl:attribute name="test" namespace="">
	      <xsl:choose>
		<xsl:when  test="@preReq and @preReq ne ''">not(contains($prereqres, '=;'))</xsl:when>
		<xsl:otherwise>'true'</xsl:otherwise>
	      </xsl:choose>
	    </xsl:attribute>

	    <xsl:element name="xsl:element"> 
	      <xsl:attribute name="name">test</xsl:attribute>

	      <xsl:element name="xsl:attribute"> 
		<xsl:attribute name="name" namespace="">tassertion</xsl:attribute>
		<xsl:value-of select="@id"/>
	      </xsl:element> 

	      <xsl:element name="xsl:attribute"> 
		<xsl:attribute name="name" namespace="">prescription</xsl:attribute>
		<xsl:element name="xsl:value-of">
		  <xsl:attribute name="select">$prescription</xsl:attribute>
		</xsl:element>
	      </xsl:element> 

	      <xsl:element name="xsl:attribute"> 
		<xsl:attribute name="name" namespace="">artifact</xsl:attribute>
		<xsl:element name="xsl:value-of">
		  <xsl:attribute name="select">$tgtype</xsl:attribute>
		</xsl:element>
	      </xsl:element> 

	      <xsl:element name="xsl:attribute"> 
		<xsl:attribute name="name" namespace="">target</xsl:attribute>
		<xsl:element name="xsl:value-of">
		  <xsl:attribute name="select">$target</xsl:attribute>
		</xsl:element>
	      </xsl:element> 

	      <xsl:element name="xsl:attribute"> 
		<xsl:attribute name="name" namespace="">id</xsl:attribute>
		<xsl:element name="xsl:value-of">
		  <xsl:attribute name="select">$logentry</xsl:attribute>
		</xsl:element>
	      </xsl:element> 

	      <xsl:element name="xsl:choose"> 

		<xsl:if  test="@preReq and @preReq ne ''">
		  <xsl:element name="xsl:when"> 
		    <xsl:attribute name="test" namespace="">contains($prereqres, '=false') or contains($prereqres, '=notrelvt')</xsl:attribute>
		    <xsl:element name="xsl:attribute"> 
		      <xsl:attribute name="name" namespace="">result</xsl:attribute>
		      <xsl:value-of>notrelvt</xsl:value-of>
		    </xsl:element>
		    <xsl:element name="xsl:element"> 
		      <xsl:attribute name="name" namespace="">wsi-rep:prereqFailedList</xsl:attribute>
		      <xsl:call-template name="checkprereqs">
			<xsl:with-param name="prereqstr" select="@preReq"/>
		      </xsl:call-template>
		    </xsl:element>
		  </xsl:element> <!-- when -->
		</xsl:if>

		<xsl:if  test="p:cotarget">

		  <xsl:element name="xsl:when"> 
		    <xsl:attribute name="test" namespace="">
		      <!-- xsl:value-of select="concat('$cotarget_', p:cotarget/@name, ' = &quot;&quot;')"/ -->
		      <xsl:value-of select="concat('not(fn:exists($cotarget_', p:cotarget[1]/@name, '))')"/>
		    </xsl:attribute>
		    <xsl:element name="xsl:attribute"> 
		      <xsl:attribute name="name" namespace="">result</xsl:attribute>
		      <xsl:value-of>misinput</xsl:value-of>
		    </xsl:element>
		  </xsl:element> <!-- when -->
<!-- CHG -->
	<xsl:if  test="count(p:cotarget) gt 1">
		  <xsl:element name="xsl:when"> 
		    <xsl:attribute name="test" namespace="">
		      <!-- xsl:value-of select="concat('$cotarget_', p:cotarget/@name, ' = &quot;&quot;')"/ -->
		      <xsl:value-of select="concat('not(fn:exists($cotarget_', p:cotarget[2]/@name, '))')"/>
		    </xsl:attribute>
		    <xsl:element name="xsl:attribute"> 
		      <xsl:attribute name="name" namespace="">result</xsl:attribute>
		      <xsl:value-of>misinput</xsl:value-of>
		    </xsl:element>
		  </xsl:element> <!-- when -->

		</xsl:if>
		</xsl:if>

		<xsl:if test="p:prerequisite">
		  <xsl:variable name="newprereq">
		    <xsl:choose>
<!-- CHG -->
		      <xsl:when test="count(p:cotarget) eq 1">
			<xsl:value-of select="concat( 'not( ', 
					      fn:replace(
					      fn:replace(
					      p:prerequisite, fn:concat('\$',p:cotarget[1]/@name), fn:concat('\$cotarget_', p:cotarget[1]/@name) ), 
					      '\$target', '\$mytarget')  , 
					      ')') "/>
		      </xsl:when>
		      <xsl:when test="count(p:cotarget) eq 2">
			<xsl:value-of select="concat( 'not( ', 
					      fn:replace(
					      fn:replace(
					      fn:replace(
					      p:prerequisite, fn:concat('\$',p:cotarget[1]/@name), fn:concat('\$cotarget_', p:cotarget[1]/@name) ), 
					      fn:concat('\$',p:cotarget[2]/@name), fn:concat('\$cotarget_', p:cotarget[2]/@name) ),
					      '\$target', '\$mytarget')  , 
					      ')') "/>
		      </xsl:when>
		      <xsl:otherwise>
			<xsl:value-of select="concat( 'not( ', 
					      fn:replace(p:prerequisite, '\$target', '\$mytarget'), ')') "/>
		      </xsl:otherwise>
		    </xsl:choose>
		  </xsl:variable>
		  <xsl:element name="xsl:when"> 
		    <xsl:attribute name="test" namespace="">
		      <xsl:value-of select="$newprereq"/>
		    </xsl:attribute>
		    <xsl:element name="xsl:attribute"> 
		      <xsl:attribute name="name" namespace="">result</xsl:attribute>
		      <xsl:value-of>notrelvt</xsl:value-of>
		    </xsl:element>
		  </xsl:element> <!-- when -->
		</xsl:if>

		  <xsl:variable name="predexpr">
		    <xsl:choose>
<!-- CHG -->
		      <xsl:when test="count(p:cotarget) eq 1">
			<xsl:value-of select="fn:replace(
					      fn:replace(
					      p:predicate, fn:concat('\$',p:cotarget[1]/@name), fn:concat('\$cotarget_', p:cotarget[1]/@name) ), 
					      '\$target', '\$mytarget')"/>
		      </xsl:when>
		      <xsl:when test="count(p:cotarget) eq 2">
			<xsl:value-of select="fn:replace(
					      fn:replace(
					      fn:replace(
					      p:predicate, fn:concat('\$',p:cotarget[1]/@name), fn:concat('\$cotarget_', p:cotarget[1]/@name) ), 
					      fn:concat('\$',p:cotarget[2]/@name), fn:concat('\$cotarget_', p:cotarget[2]/@name) ),
					      '\$target', '\$mytarget')"/>
		      </xsl:when>
		      <xsl:otherwise>
			<xsl:value-of select="fn:replace(p:predicate, '\$target', '\$mytarget')"/>
		      </xsl:otherwise>
		    </xsl:choose>
		  </xsl:variable>

		<xsl:element name="xsl:when"> 
		  <xsl:attribute name="test" namespace="">
		    <xsl:value-of select="$predexpr"/>
		  </xsl:attribute>
		  <xsl:element name="xsl:attribute"> 
		    <xsl:attribute name="name" namespace="">result</xsl:attribute>
		    <xsl:value-of>true</xsl:value-of>
		  </xsl:element>
		  
		  <xsl:if  test="p:reporting/@true = 'warning' or p:reporting/@true = 'false'">
		  <xsl:element name="xsl:element"> 
		    <xsl:attribute name="name" namespace="">errmessage</xsl:attribute>
		    <xsl:value-of select="p:errorMessage"/>
		  </xsl:element>
		  <xsl:element name="xsl:element"> 
		    <xsl:attribute name="name" namespace="">errdiagnostic</xsl:attribute>
		    <xsl:element name="xsl:copy-of"> 
		      <xsl:attribute name="select" namespace="">current()</xsl:attribute>
		    </xsl:element>
		  </xsl:element>

		  </xsl:if>
		</xsl:element> <!-- when -->

		<xsl:element name="xsl:otherwise"> 
		  <xsl:element name="xsl:attribute"> 
		    <xsl:attribute name="name" namespace="">result</xsl:attribute>
		    <xsl:value-of>false</xsl:value-of>
		  </xsl:element>

		  <xsl:element name="xsl:element"> 
		    <xsl:attribute name="name" namespace="">errmessage</xsl:attribute>
		    <xsl:value-of select="p:errorMessage"/>
		  </xsl:element>
		  <xsl:element name="xsl:element"> 
		    <xsl:attribute name="name" namespace="">errdiagnostic</xsl:attribute>
		    <xsl:element name="xsl:copy-of"> 
		      <xsl:attribute name="select" namespace="">current()</xsl:attribute>
		    </xsl:element>
		  </xsl:element>
		</xsl:element> <!-- otherwise -->

	      </xsl:element> <!-- choose -->

	      <!-- reporting element -->
	      <xsl:element name="wsi-rep:reporting"> 
	      <xsl:choose>
		<xsl:when  test="p:reporting">
		    <xsl:attribute name="truePredicateAs" namespace=""><xsl:value-of select="p:reporting/@true"/></xsl:attribute>
		    <xsl:attribute name="falsePredicateAs" namespace=""><xsl:value-of select="p:reporting/@false"/></xsl:attribute>
		</xsl:when>
		<xsl:otherwise>
		    <xsl:attribute name="truePredicateAs" namespace="">passed</xsl:attribute>
		    <xsl:attribute name="falsePredicateAs" namespace="">failed</xsl:attribute>
		</xsl:otherwise>
	      </xsl:choose>
	      </xsl:element> <!-- end reporting element -->

	    </xsl:element> <!-- end gen element -->
	  </xsl:element> <!-- end gen when -->
	  <xsl:element name="xsl:otherwise"/> 
	</xsl:element> <!-- end gen choose -->
      </xsl:element> <!-- end gen if -->

      <xsl:element name="xsl:next-match"> 
	<xsl:element name="xsl:with-param"> 
	  <xsl:attribute name="name" namespace="">tgtype</xsl:attribute>
	  <xsl:attribute name="select" namespace="">$tgtype</xsl:attribute>
	</xsl:element> 
	<xsl:element name="xsl:with-param"> 
	  <xsl:attribute name="name" namespace="">target</xsl:attribute>
	  <xsl:attribute name="select" namespace="">$target</xsl:attribute>
	</xsl:element> 
	<xsl:element name="xsl:with-param"> 
	  <xsl:attribute name="name" namespace="">tempresults</xsl:attribute>
	  <xsl:attribute name="select" namespace="">$tempresults</xsl:attribute>
	</xsl:element> 
	<xsl:element name="xsl:with-param"> 
	  <xsl:attribute name="name" namespace="">taoutlist</xsl:attribute>
	  <xsl:attribute name="select" namespace="">$newtaoutlist</xsl:attribute>
	</xsl:element> 

      </xsl:element> <!-- end gen next-match -->

    </xsl:element> <!-- end gen template -->

  </xsl:template>

  <xsl:template name="checkprereqs">
    <xsl:param name="prereqstr"/>
    <xsl:variable name="taid">
      <xsl:choose>
	<xsl:when test="contains($prereqstr, ' ')">
	  <xsl:value-of select="fn:substring-before($prereqstr, ' ')"/>
	</xsl:when>
	<xsl:otherwise>
	  <xsl:value-of select="$prereqstr"/>
	</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="v1">fn:starts-with(fn:substring-after($prereqres, &quot;</xsl:variable>
    <xsl:variable name="v2">&quot;), &quot;=false&quot;)</xsl:variable>
    <xsl:variable name="v3">&quot;), &quot;=notrelvt&quot;)</xsl:variable>

    <xsl:element name="xsl:if">
      <xsl:attribute name="test" namespace="">
	<xsl:value-of select="concat( $v1, $taid, $v2, ' or ', $v1, $taid, $v3) "/>
      </xsl:attribute>
      <xsl:element name="xsl:element"> 
	<xsl:attribute name="name" namespace="">wsi-rep:testAssertionID</xsl:attribute>
	<xsl:element name="xsl:text"> 
	  <xsl:value-of select="$taid"/>
	</xsl:element> 
      </xsl:element> 
    </xsl:element> 
    <xsl:if test="contains($prereqstr, ' ')">
      <xsl:call-template name="checkprereqs">
	<xsl:with-param name="prereqstr" select="substring-after($prereqstr, ' ')"/>
      </xsl:call-template>
    </xsl:if>
  </xsl:template>

  <xsl:template name="reportprereqs">
    <xsl:param name="prereqstr"/>
    <xsl:variable name="v1">$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &quot;:&quot;) and fn:starts-with($logentry, @id))][@tassertion eq &quot;</xsl:variable>
    <xsl:variable name="v2">&quot;][1]/@result, &quot;;&quot; </xsl:variable>
    <xsl:choose>
      <xsl:when test="not(contains($prereqstr, ' '))">
	<xsl:value-of select="concat('&quot;', $prereqstr, '=&quot;,', $v1, $prereqstr , $v2)"/>
      </xsl:when>
      <xsl:when test="contains($prereqstr, ' ')">
	<xsl:value-of select="concat('&quot;', fn:substring-before($prereqstr, ' '), '=&quot;,', $v1, fn:substring-before($prereqstr, ' ') , $v2, ',')"/>
	<xsl:call-template name="reportprereqs">
	  <xsl:with-param name="prereqstr" select="substring-after($prereqstr, ' ')"/>
	</xsl:call-template>
      </xsl:when>
      <xsl:otherwise/>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="getalltas">
    <xsl:param name="tatype"/>
    <xsl:param name="tapos"/>
    <xsl:if test="xsd:integer($tapos) gt 1">
      <xsl:call-template name="getalltas">
	<xsl:with-param name="tatype" select="$tatype"/>
	<xsl:with-param name="tapos" select="xsd:integer($tapos) - 1"/>
      </xsl:call-template>
    </xsl:if>
    <xsl:choose>
      <xsl:when test="$tatype = 'message'">
	<xsl:value-of select="fn:concat(//*:testAssertion[not(@enable) or @enable = 'true'][fn:starts-with(@id, 'BP1') or fn:starts-with(@id, 'RSP')][fn:position() = $tapos]/@id, ';')"/>
      </xsl:when>
      <xsl:when test="$tatype = 'description'">
	<xsl:value-of select="fn:concat(//*:testAssertion[not(@enable) or @enable = 'true'][fn:starts-with(@id, 'BP2')][fn:position() = $tapos]/@id, ';')"/>
      </xsl:when>
      <xsl:otherwise/>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="setAnalyzerInfo">

    <xsl:element name="xsl:template"> 
      <xsl:attribute name="name" namespace="">getAnalyzerInfo</xsl:attribute>
      <xsl:element name="wsit:profilename">
	<xsl:value-of select="fn:concat(//p:head/p:title, ' Version ', //p:head/p:version)"/>
      </xsl:element>
      <xsl:element name="wsit:profilerev">
	<xsl:value-of select="//p:head/p:webRevision"/>
      </xsl:element>
      <xsl:element name="wsit:profileimpname">
	<xsl:value-of select="fn:concat('Web Services Interoperability Org. (', //p:head/p:wgName, ' WG)')"/>
      </xsl:element>
      <xsl:element name="wsit:profileimplocn">
	<xsl:text>http://www.ws-i.org</xsl:text>
      </xsl:element>
      <xsl:element name="wsit:analyzervn">
	<xsl:text>V2.0</xsl:text>
      </xsl:element>
      <xsl:element name="wsit:analyzerdate">
	<xsl:text>2009-09-10</xsl:text>
      </xsl:element>
      <xsl:element name="wsit:analyzerimpname">
	<xsl:text>Web Services Interoperability Organization</xsl:text>
      </xsl:element>
      <xsl:element name="wsit:analyzerimplocn">
	<xsl:text>http://www.ws-i.org</xsl:text>
      </xsl:element>
      <xsl:element name="wsit:analyzergentime">
	<xsl:value-of select="fn:current-dateTime()"/>
      </xsl:element>
      <xsl:element name="analyzergenxsltname">
	<xsl:value-of select="$globalparameters/wsit:analyzergenxsltname"/>
      </xsl:element>
      <xsl:element name="analyzergenxsltvn">
	<xsl:value-of select="$globalparameters/wsit:analyzergenxsltvn"/>
      </xsl:element>
      <xsl:comment>Set with the XSLT engine used to run this Analyzer script:</xsl:comment>
      <xsl:text>&#10;</xsl:text>
      <xsl:element name="runxsltname">
	<xsl:text>Saxon B</xsl:text>
      </xsl:element>
      <xsl:comment>Set with comments to appear in test reports produced with this Analyzer:</xsl:comment>
      <xsl:text>&#10;</xsl:text>
      <xsl:element name="runcomment">
	<xsl:text>no comments</xsl:text>
      </xsl:element>

    </xsl:element>
    <xsl:text>&#10;</xsl:text>

  </xsl:template>

</xsl:stylesheet>

